!!  ALLL THE REGULAR VIEW STUFF UP HERE

listen ("Do you want to export the results? {y n}[n] ",$export)
if $export == true
	! START PROJECT Specific export prep
	local inputToSubRoutStrs[] = create (; object=set, \
		elemName1="/models/tcteem/merged/V8/exportData/", \
		elemName2="regulationsRpt") ! NOTE this should be the general subject of what you are exporting... generally the view name is a good idea
	
	local exportDirSet[]
	string $exportDataProjectSubjectPath, $exportFileName
	localinformant exportDirSetInf[]

	say ("")
	tool $informPath/getProjectExportPath.t \
		inputToSubRoutStrs[] \
		exportDirSet[] 		
	exportDirSetInf[] = exportDirSet[] 
	getobjinfo (exportDirSetInf[], $exportDataProjectSubjectPath; info=elementName, elementNum=1)

	say ("    exporting to: ", $exportDataProjectSubjectPath)
	! END PROJECT Specific export prep

	for $i from 2 upto $numScns
		say ("")
		say ("    exporting data for ", $scnNames[$i], ": '", $scnDescs[$i], "'...")

		say ("")
		buildstring ($exportFileName, $exportDataProjectSubjectPath, "/(scnNum=",$scnNumbers[$i],")_regulationACompliance_", $scnDescs[$i], ".csv")
		say ("      exporting to: ", $exportFileName)
		export (regulationACompliance[variousDimensions][$i]; dataFormat="coordinate", heading=on, \
				fileFormat="text", delimiter=",", decimals=6,  expForm=on, file=$exportFileName)
	endfor
endif