input transYearsDefault[e] !real
input percentageChangeDefault[e] !real
input inEffVarHis[upperDims,ts]
input boundsChecking[boundsInfoSet]
output outEffVar[upperDims,ts]

local quietUseDefaults[] = create(; dataType=integer, data=0)

outEffVar[upperDims,ts] = 0

integer $rank, $rankM1
getobjinfo (outEffVar[upperDims,ts], $rank; info=rank)
$rankM1 = $rank - 1

local inEffVarHisFiltered[upperDimsFiltered,ts] = inEffVarHis[upperDims,ts]
local outEffVarFiltered[upperDimsFiltered,ts] = outEffVar[upperDims,ts]
local inEffVarHisFiltered_tmp[upperDimsFiltered,ts]
local outEffVarFiltered_tmp[upperDimsFiltered,ts] 
local dimVector[], dimFiltered[]

integer $i
for $i from 1 upto $rankM1
	delete (dimVector[], dimFiltered[])
	if ($i = 1)
		dimVector[] = create (; dimFrom1=outEffVar[upperDims,ts], data=0)
	endif
	if ($i = 2)
		dimVector[] = create (; dimFrom2=outEffVar[upperDims,ts], data=0)
	endif
	if ($i = 3)
		dimVector[] = create (; dimFrom3=outEffVar[upperDims,ts], data=0)
	endif
	if ($i = 4)
		dimVector[] = create (; dimFrom4=outEffVar[upperDims,ts], data=0)
	endif
	if ($i = 5)
		dimVector[] = create (; dimFrom5=outEffVar[upperDims,ts], data=0)
	endif
	
	local chosenElems[] = copyshape (dimVector[])
	chosenElems[] = table (; with=dimVector[], title="enter a 1 for elements to change...")
	dimFiltered[] = extract (chosenElems[]; extractTo=set)
	
	outEffVarFiltered_tmp[upperDimsFiltered,ts] = outEffVarFiltered[upperDimsFiltered,ts]
	outEffVarFiltered[upperDimsFiltered,ts] = map (outEffVarFiltered_tmp[upperDimsFiltered,ts]; $i->dimFiltered)

	inEffVarHisFiltered_tmp[upperDimsFiltered,ts] = inEffVarHisFiltered[upperDimsFiltered,ts]
	inEffVarHisFiltered[upperDimsFiltered,ts] = map (inEffVarHisFiltered_tmp[upperDimsFiltered,ts]; $i->dimFiltered)
	seeshape (inEffVarHisFiltered[upperDimsFiltered,ts], outEffVarFiltered[upperDimsFiltered,ts])
endfor

tool $informPath/stepwiseChangeQuietOption.t \
		transYearsDefault[e] \
		percentageChangeDefault[e] \
		inEffVarHisFiltered[upperDims,ts] \
		boundsChecking[boundsInfoSet] \
		quietUseDefaults[] \
		outEffVarFiltered[upperDims,ts] 
		
for $i from 1 upto $rankM1
!! Can't quite figure out how to get it mapped back!
	outEffVar[upperDims,ts] = map (outEffVarFiltered[upperDims,ts]; $i->
endfor
	