input transYearsDefault[e] !real
input percentageDecreaseDefault[e] !real
input inEffVarHis[upperDims,ts]
output outEffVar[upperDims,ts]

integer $firstScnYr, $firstScnYrM1
getobjinfo (outEffVar[upperDims,ts], $firstScnYr; info=sequenceStart, dim=time)
$firstScnYrM1 = $firstScnYr - 1

local oneEvent[e] = create (; dim=SEQ;event:1:5:1;event, data=1.0)

local transitionYear_bck[upperDims,e] = changeshape (copyshape (inEffVarHis[upperDims,ts]); \
	deleteDims:time, entity="-", SIuom="-", altUom="-") * oneEvent[e]
transitionYear_bck[upperDims,e] = insert (transYearsDefault[e])
local transitionYear[upperDims,e] = copyshape (transitionYear_bck[upperDims,e])
transitionYear[upperDims,e] = table (; with=transitionYear_bck[upperDims,e], title="enter your year for transitions")

local percentageDecrease_bck[upperDims,e] = copyshape (transitionYear_bck[upperDims,e])
percentageDecrease_bck[upperDims,e] = insert (percentageDecreaseDefault[e])
local percentageDecrease[upperDims,e] = copyshape (percentageDecrease_bck[upperDims,e])
percentageDecrease[upperDims,e] = table (; with=percentageDecrease_bck[upperDims,e], title="enter transition percentage decrease")

local yearOfChange[upperDims], multiplierThisEvent[upperDims]
local prepLinIntAllEvents[upperDims,ts], prepLinIntAllEventsx[upperDims,ts], prepLinIntThisEvent[upperDims,ts]
prepLinIntAllEvents[upperDims,ts] = changeshape (copyshape (outEffVar[upperDims,ts]); entity="-", SIuom="-", altUom="-")
prepLinIntAllEvents[upperDims,ts] = 0.0

local one[upperDims,ts] = copyshape (prepLinIntAllEvents[upperDims,ts])
one[upperDims,ts] = 1.0

integer $i
for $i from 1 upto 5
	yearOfChange[upperDims] = extract (transitionYear[upperDims,e]; event:$i, shrink=on)
	multiplierThisEvent[upperDims] = extract (percentageDecrease[upperDims,e]; event:$i, shrink=on) / 100 * -1 + 1
	
	prepLinIntThisEvent[upperDims,ts] = booleq (cumsum (one[upperDims,ts]; \
		multiplyEntity=off) + $firstScnYrM1, \
		yearOfChange[upperDims]) * multiplierThisEvent[upperDims]
	
	prepLinIntAllEventsx[upperDims,ts] = prepLinIntAllEvents[upperDims,ts] + prepLinIntThisEvent[upperDims,ts]
	prepLinIntAllEvents[upperDims,ts] = prepLinIntAllEventsx[upperDims,ts]
endfor

prepLinIntAllEvents[upperDims,ts] = insert (1.0; time:+0)
local multiplierAllTime[upperDims,ts] = linint (prepLinIntAllEvents[upperDims,ts]; start=on, fixedEnd=on)
local valLastYearHis[upperDims] = extract (inEffVarHis[upperDims,ts]; time:-0, shrink=on)
outEffVar[upperDims,ts] = valLastYearHis[upperDims] * multiplierAllTime[upperDims,ts]


boolean $seeResults
say ("")
listen ("Do you want to see your results? {y n}[n] ",$seeResults)
if $seeResults == true
	graph (inEffVarHis[upperDims,ts], \
		outEffVar[upperDims,ts]; \
		title2="history and projection of efficiency")
endif

